----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 01/26/2018 12:26:00 PM
-- Design Name: 
-- Module Name: beastlink_exdes_top - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity beastlink_exdes_top is
Port
(
  sys_clk_p       : in std_logic;
  sys_clk_n       : in std_logic;

  sys_rst         : in std_logic;

  o_fx3_pclk      : out std_logic;
  i_fx3_pclk      : in std_logic;
  i_fx3_flag      : in std_logic_vector(3 downto 0);
  o_fx3_slcs_n    : out std_logic;
  o_fx3_slrd_n    : out std_logic;
  o_fx3_slwr_n    : out std_logic;
  o_fx3_sloe_n    : out std_logic;
  o_fx3_pktend_n  : out std_logic;
  o_fx3_faddr     : out std_logic_vector(1 downto 0);
  io_fx3_fdata    : inout std_logic_vector(31 downto 0)
);
end beastlink_exdes_top;

architecture Behavioral of beastlink_exdes_top is

component BeastLink_0 is
  port (
    sys_clk         : in std_logic;
    i_reset         : in std_logic;

    i_fx3_pclk      : in std_logic;
    o_fx3_pclk      : out std_logic;
    i_fx3_flag      : in std_logic_vector(3 downto 0);
    o_fx3_slcs_n    : out std_logic;
    o_fx3_slrd_n    : out std_logic;
    o_fx3_slwr_n    : out std_logic;
    o_fx3_sloe_n    : out std_logic;
    o_fx3_pktend_n  : out std_logic;
    o_fx3_faddr     : out std_logic_vector(1 downto 0);
    io_fx3_fdata    : inout std_logic_vector(31 downto 0);

    m_axi_araddr    : out std_logic_vector(31 downto 0);
    m_axi_arburst   : out std_logic_vector(1 downto 0);
    m_axi_arcache   : out std_logic_vector(3 downto 0);
    m_axi_arlen     : out std_logic_vector(7 downto 0);
    m_axi_arprot    : out std_logic_vector(2 downto 0);
    m_axi_arready   : in std_logic;
    m_axi_arsize    : out std_logic_vector(2 downto 0);
    m_axi_aruser    : out std_logic_vector(3 downto 0);
    m_axi_arvalid   : out std_logic;

    m_axi_rdata     : in std_logic_vector(31 downto 0);
    m_axi_rlast     : in std_logic;
    m_axi_rready    : out std_logic;
    m_axi_rresp     : in std_logic_vector(1 downto 0);
    m_axi_rvalid    : in std_logic;

    m_axi_awaddr    : out std_logic_vector(31 downto 0);
    m_axi_awburst   : out std_logic_vector(1 downto 0);
    m_axi_awcache   : out std_logic_vector(3 downto 0);
    m_axi_awlen     : out std_logic_vector(7 downto 0);
    m_axi_awprot    : out std_logic_vector(2 downto 0);
    m_axi_awready   : in std_logic;
    m_axi_awsize    : out std_logic_vector(2 downto 0);
    m_axi_awuser    : out std_logic_vector(3 downto 0);
    m_axi_awvalid   : out std_logic;

    m_axi_bready    : out std_logic;
    m_axi_bresp     : in std_logic_vector(1 downto 0);
    m_axi_bvalid    : in std_logic;

    m_axi_wdata     : out std_logic_vector(31 downto 0);
    m_axi_wlast     : out std_logic;
    m_axi_wready    : in std_logic;
    m_axi_wstrb     : out std_logic_vector(3 downto 0);
    m_axi_wvalid    : out std_logic;

    o_wr_err        : out std_logic;
    s_s2mm_status   : out std_logic_vector(7 downto 0);

    o_rd_err        : out std_logic;
    s_mm2s_status   : out std_logic_vector(7 downto 0)
  );
end component;

component blk_mem_gen_0 is
  port (
    s_aclk        : in std_logic;
    s_aresetn     : in std_logic;
    
    s_axi_awid    : in std_logic_vector(3 downto 0);
    s_axi_awaddr  : in std_logic_vector(31 downto 0);
    s_axi_awlen   : in std_logic_vector(7 downto 0);
    s_axi_awsize  : in std_logic_vector(2 downto 0);
    s_axi_awburst : in std_logic_vector(1 downto 0);
    s_axi_awvalid : in std_logic;
    s_axi_awready : out std_logic;

    s_axi_wdata   : in std_logic_vector(31 downto 0);
    s_axi_wstrb   : in std_logic_vector(3 downto 0);
    s_axi_wlast   : in std_logic;
    s_axi_wvalid  : in std_logic;
    s_axi_wready  : out std_logic;

    s_axi_bid     : out std_logic_vector(3 downto 0);
    s_axi_bresp   : out std_logic_vector(1 downto 0);
    s_axi_bvalid  : out std_logic;
    s_axi_bready  : in std_logic;

    s_axi_arid    : in std_logic_vector(3 downto 0);
    s_axi_araddr  : in std_logic_vector(31 downto 0);
    s_axi_arlen   : in std_logic_vector(7 downto 0);
    s_axi_arsize  : in std_logic_vector(2 downto 0);
    s_axi_arburst : in std_logic_vector(1 downto 0);
    s_axi_arvalid : in std_logic;
    s_axi_arready : out std_logic;

    s_axi_rid     : out std_logic_vector(3 downto 0);
    s_axi_rdata   : out std_logic_vector(31 downto 0);
    s_axi_rresp   : out std_logic_vector(1 downto 0);
    s_axi_rlast   : out std_logic;
    s_axi_rvalid  : out std_logic;
    s_axi_rready  : in std_logic
  );
end component;

signal axi_awid    : std_logic_vector(3 downto 0);
signal axi_awaddr  : std_logic_vector(31 downto 0);
signal axi_awlen   : std_logic_vector(7 downto 0);
signal axi_awsize  : std_logic_vector(2 downto 0);
signal axi_awburst : std_logic_vector(1 downto 0);
signal axi_awvalid : std_logic;
signal axi_awready : std_logic;
signal axi_wdata   : std_logic_vector(31 downto 0);
signal axi_wstrb   : std_logic_vector(3 downto 0);
signal axi_wlast   : std_logic;
signal axi_wvalid  : std_logic;
signal axi_wready  : std_logic;
signal axi_bid     : std_logic_vector(3 downto 0);
signal axi_bresp   : std_logic_vector(1 downto 0);
signal axi_bvalid  : std_logic;
signal axi_bready  : std_logic;
signal axi_arid    : std_logic_vector(3 downto 0);
signal axi_araddr  : std_logic_vector(31 downto 0);
signal axi_arlen   : std_logic_vector(7 downto 0);
signal axi_arsize  : std_logic_vector(2 downto 0);
signal axi_arburst : std_logic_vector(1 downto 0);
signal axi_arvalid : std_logic;
signal axi_arready : std_logic;
signal axi_rid     : std_logic_vector(3 downto 0);
signal axi_rdata   : std_logic_vector(31 downto 0);
signal axi_rresp   : std_logic_vector(1 downto 0);
signal axi_rlast   : std_logic;
signal axi_rvalid  : std_logic;
signal axi_rready  : std_logic;

signal aclk        : std_logic;
signal aresetn     : std_logic;

signal CLKFBOUT     : std_logic;
signal sys_clk     : std_logic;

begin

   IBUFDS_inst : IBUFDS
   generic map (
      DIFF_TERM     => FALSE,     -- Differential Termination 
      IBUF_LOW_PWR  => TRUE,      -- Low power (TRUE) vs. performance (FALSE) setting for referenced I/O standards
      IOSTANDARD    => "DEFAULT")
   port map (
      O   => sys_clk,     -- Buffer output
      I   => sys_clk_p,   -- Diff_p buffer input (connect directly to top-level port)
      IB  => sys_clk_n    -- Diff_n buffer input (connect directly to top-level port)
   );

   MMCME2_BASE_inst : MMCME2_BASE
   generic map (
      BANDWIDTH => "OPTIMIZED",  -- Jitter programming (OPTIMIZED, HIGH, LOW)
      CLKFBOUT_MULT_F => 5.0,    -- Multiply value for all CLKOUT (2.000-64.000).
      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB (-360.000-360.000).
      CLKIN1_PERIOD => 5.0,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
      -- CLKOUT0_DIVIDE - CLKOUT6_DIVIDE: Divide amount for each CLKOUT (1-128)
      CLKOUT1_DIVIDE => 1,
      CLKOUT2_DIVIDE => 1,
      CLKOUT3_DIVIDE => 1,
      CLKOUT4_DIVIDE => 1,
      CLKOUT5_DIVIDE => 1,
      CLKOUT6_DIVIDE => 1,
      CLKOUT0_DIVIDE_F => 10.000,   -- Divide amount for CLKOUT0 (1.000-128.000).
      -- CLKOUT0_DUTY_CYCLE - CLKOUT6_DUTY_CYCLE: Duty cycle for each CLKOUT (0.01-0.99).
      CLKOUT0_DUTY_CYCLE => 0.5,
      CLKOUT1_DUTY_CYCLE => 0.5,
      CLKOUT2_DUTY_CYCLE => 0.5,
      CLKOUT3_DUTY_CYCLE => 0.5,
      CLKOUT4_DUTY_CYCLE => 0.5,
      CLKOUT5_DUTY_CYCLE => 0.5,
      CLKOUT6_DUTY_CYCLE => 0.5,
      -- CLKOUT0_PHASE - CLKOUT6_PHASE: Phase offset for each CLKOUT (-360.000-360.000).
      CLKOUT0_PHASE => 0.0,
      CLKOUT1_PHASE => 0.0,
      CLKOUT2_PHASE => 0.0,
      CLKOUT3_PHASE => 0.0,
      CLKOUT4_PHASE => 0.0,
      CLKOUT5_PHASE => 0.0,
      CLKOUT6_PHASE => 0.0,
      CLKOUT4_CASCADE => FALSE,  -- Cascade CLKOUT4 counter with CLKOUT6 (FALSE, TRUE)
      DIVCLK_DIVIDE => 1,        -- Master division value (1-106)
      REF_JITTER1 => 0.0,        -- Reference input jitter in UI (0.000-0.999).
      STARTUP_WAIT => FALSE      -- Delays DONE until MMCM is locked (FALSE, TRUE)
   )
   port map (
      -- Clock Outputs: 1-bit (each) output: User configurable clock outputs
      CLKOUT0  => aclk, -- 1-bit output: CLKOUT0
      CLKOUT0B => open, -- 1-bit output: Inverted CLKOUT0
      CLKOUT1  => open, -- 1-bit output: CLKOUT1
      CLKOUT1B => open, -- 1-bit output: Inverted CLKOUT1
      CLKOUT2  => open, -- 1-bit output: CLKOUT2
      CLKOUT2B => open, -- 1-bit output: Inverted CLKOUT2
      CLKOUT3  => open, -- 1-bit output: CLKOUT3
      CLKOUT3B => open, -- 1-bit output: Inverted CLKOUT3
      CLKOUT4  => open, -- 1-bit output: CLKOUT4
      CLKOUT5  => open, -- 1-bit output: CLKOUT5
      CLKOUT6  => open, -- 1-bit output: CLKOUT6
      -- Feedback Clocks: 1-bit (each) output: Clock feedback ports
      CLKFBOUT => CLKFBOUT,   -- 1-bit output: Feedback clock
      CLKFBOUTB => open,      -- 1-bit output: Inverted CLKFBOUT
      -- Status Ports: 1-bit (each) output: MMCM status ports
      LOCKED => aresetn,      -- 1-bit output: LOCK
      -- Clock Inputs: 1-bit (each) input: Clock input
      CLKIN1 => sys_clk,      -- 1-bit input: Clock
      -- Control Ports: 1-bit (each) input: MMCM control ports
      PWRDWN => '0' ,         -- 1-bit input: Power-down
      RST => sys_rst,         -- 1-bit input: Reset
      -- Feedback Clocks: 1-bit (each) input: Clock feedback ports
      CLKFBIN => CLKFBOUT     -- 1-bit input: Feedback clock
   );
   -- End of MMCME2_BASE_inst instantiation

inst_axi_bram:
component blk_mem_gen_0 port map
(
  s_aclk        => aclk        ,
  s_aresetn     => aresetn     ,
  s_axi_awid    => axi_awid    ,
  s_axi_awaddr  => axi_awaddr  ,
  s_axi_awlen   => axi_awlen   ,
  s_axi_awsize  => axi_awsize  ,
  s_axi_awburst => axi_awburst ,
  s_axi_awvalid => axi_awvalid ,
  s_axi_awready => axi_awready ,
  s_axi_wdata   => axi_wdata   ,
  s_axi_wstrb   => axi_wstrb   ,
  s_axi_wlast   => axi_wlast   ,
  s_axi_wvalid  => axi_wvalid  ,
  s_axi_wready  => axi_wready  ,
  s_axi_bid     => axi_bid     ,
  s_axi_bresp   => axi_bresp   ,
  s_axi_bvalid  => axi_bvalid  ,
  s_axi_bready  => axi_bready  ,
  s_axi_arid    => axi_arid    ,
  s_axi_araddr  => axi_araddr  ,
  s_axi_arlen   => axi_arlen   ,
  s_axi_arsize  => axi_arsize  ,
  s_axi_arburst => axi_arburst ,
  s_axi_arvalid => axi_arvalid ,
  s_axi_arready => axi_arready ,
  s_axi_rid     => axi_rid     ,
  s_axi_rdata   => axi_rdata   ,
  s_axi_rresp   => axi_rresp   ,
  s_axi_rlast   => axi_rlast   ,
  s_axi_rvalid  => axi_rvalid  ,
  s_axi_rready  => axi_rready  
);

inst_beastlink: component beastlink_0 port map
(
  sys_clk         => aclk     ,
  i_reset         => aresetn  ,

  i_fx3_pclk      => i_fx3_pclk      ,
  o_fx3_pclk      => o_fx3_pclk      ,
  i_fx3_flag      => i_fx3_flag      ,
  o_fx3_slcs_n    => o_fx3_slcs_n    ,
  o_fx3_slrd_n    => o_fx3_slrd_n    ,
  o_fx3_slwr_n    => o_fx3_slwr_n    ,
  o_fx3_sloe_n    => o_fx3_sloe_n    ,
  o_fx3_pktend_n  => o_fx3_pktend_n  ,
  o_fx3_faddr     => o_fx3_faddr     ,
  io_fx3_fdata    => io_fx3_fdata    ,

  m_axi_araddr    => axi_araddr    ,
  m_axi_arburst   => axi_arburst   ,
  m_axi_arcache   => open   ,
  m_axi_arlen     => axi_arlen     ,
  m_axi_arprot    => open    ,
  m_axi_arready   => axi_arready   ,
  m_axi_arsize    => axi_arsize    ,
  m_axi_aruser    => open    ,
  m_axi_arvalid   => axi_arvalid   ,

  m_axi_rdata     => axi_rdata   ,
  m_axi_rlast     => axi_rlast   ,
  m_axi_rready    => axi_rready  ,
  m_axi_rresp     => axi_rresp   ,
  m_axi_rvalid    => axi_rvalid  ,

  m_axi_awaddr    => axi_awaddr  ,
  m_axi_awburst   => axi_awburst ,
  m_axi_awcache   => open ,
  m_axi_awlen     => axi_awlen   ,
  m_axi_awprot    => open  ,
  m_axi_awready   => axi_awready ,
  m_axi_awsize    => axi_awsize  ,
  m_axi_awuser    => open  ,
  m_axi_awvalid   => axi_awvalid ,

  m_axi_bready    => axi_bready  ,
  m_axi_bresp     => axi_bresp   ,
  m_axi_bvalid    => axi_bvalid  ,

  m_axi_wdata     => axi_wdata   ,
  m_axi_wlast     => axi_wlast   ,
  m_axi_wready    => axi_wready  ,
  m_axi_wstrb     => axi_wstrb   ,
  m_axi_wvalid    => axi_wvalid  ,

  o_wr_err        => open,
  s_s2mm_status   => open,
  o_rd_err        => open,
  s_mm2s_status   => open
);
  
end Behavioral;